{2. rijna 1996   21:38 }
   {$M 19684, 0, 655360}
program Pretty_Print;  {neboli hezkej tisk}
{===========================  UNITY  ========================================}
uses Wokynka, My, Crt, Dos;
  {Wokynka - unita na uzivatelske rozhrani (ty pekny okynka)}
  {My      - moje unitka, obsahujici mnoho potrebnych procedurek a fci}
{============================  TYPY  ========================================}
type
  {Zasobnik}
  StackPolozka = record
                   Prikaz : string;
                   Posun  : byte;
                 end;
  Stack = ^StItem;
  StItem = record
             Obsah: StackPolozka;
             Dalsi: Stack;
           end;
{============================  KONSTANTY  ===================================}
const
  MaxCykly = 15;
  {Cykly - prikazy ktere meni velikost odmezereni (posunu (Pos, SPos))}
  {Mincykl, MaxCykl - charakterizuji prikazy cyklu se stejnymi (podobnymi)
  vlastnostmi  }
  {FirstCykl1 - tyto prikazy by se mely vyskytovat na samostatne radce
   FirstCykl2 - Za temito prikazy jeste pokracuje radka (na rozdil od jinych)}
  MinCykl1 = 1; MaxCykl1 = 6; FirstCykl1 = 3; FirstCykl2 = 1;
  MinCykl2 = 7; MaxCykl2 = 8;
  MinCykl3 = 9; MaxCykl3 = 11;
  MinCykl4 = 12; MaxCykl4 = 16;

  Cykly: array [1..MaxCykly] of string = (
  'case','asm','begin','record','object','repeat',
  'end','until',
  'then','else','do',
  'uses','const','var','type');

  { Zacatky cyklu }
  MaxCykly2 = 7;
  Cykly2: array [1..MaxCykly2] of string = (
  'begin','if','while','repeat','for','case','record');

  {Oddelovace jednotlivych prikazu (slov)}
  Oddel : set of char = [#9,'''','=','<','>',' ','(',')','[',']','{','}',',',
                            ';',':','+','*','-','/','.','^'];

  {Kde se muze rozdelit radka (co muze byt na jejim konci)}
  KonecRadky : set of char = ['''',' ',',',';','+','-','*','/',')',']',
                              '}'];
  {Kde se naopak radka nesmi rozdelit}
  MaxNedelit = 4;
  Nedelit : array [1..MaxNedelit] of string = (
  (':='),('<>'),('<='),('>='));

  { Aneb cim vsim muze zacinat slovo }
  BeginOfWord : set of char = ['a'..'z','A'..'Z','_'];

  MaxProcFce = 4;   {Cim zacina hlavicka procedury, fce...}
  ProcFce : array [1..MaxProcFce] of string = (
  'procedure','function','constructor','destructor');
  {aneb cim zacina blok deklaraci}
  MaxEndDek = 7;
  EndDek: array [1..MaxEndDek] of string = (
  'procedure','function','constructor','destructor','interface',
  'implementation', 'begin');

  MaxZaProc = 6; {Prikazay, ktere se vyskytuji za strednikem (neodradkovat!)}
  ZaProc : array [1..MaxZaProc] of string = (
  'forward','virtual','external','export','far','near');

{============================  PROMENNE  ====================================}
var
  Fin, Fout        : text;       { Vstupni a vystupni soubor }
  FVyj, FZnaky     : text;       { Soubor vyjimek a znaku}
  UserFIn, UserFOut    : string;  { Cesta k vstupnimu a vystupnimu souboru}
  UserFVyj, UserFZnaky : string;  { Cesta k Souboru vyjimek a znaku}
  PomRad, Rad : string;       { Pom promenna, Aktualne zpracovavany radek }
  NewRad      : string;       { Nasledujici radek - neprazdny, pokud zbylo
                                neco z toho minuleho }
  SeznVyjimky : Seznam;   { Seznam identifikatoru promennych, proc. a  fci
                      podle ktereho se budou upravovat pismena (velka/mala) }
  SeznZnaky   : Seznam;      {Seznam spravne odmezerenych znaku}
  Zas : Stack;    { Zasobnik odmezereni cyklu (begin - end,repeat - until,...}
  Txt : boolean;{ Zda je prave zpracovavame pismeno z retezce (v apostrofech)}
  Kom : 0..2;   { Zda zpracovavame cast komentare ( 0 - Ne, 1 - {, 2 - (* ) }
  Dek : Boolean; { Zda se prave zpracovava blok deklaraci }
  UserTab    : byte;    { Velikost tabelatoru }
  UserUpDown : 0..1;    { Jak upravovat mala/velka pismenka pokud dane slovo
  neni ani vyhrazene slovo ani slovo, ktere by bylo v seznamu vyjimek
  (v seznamu casto pouzivanych slov (prikazy jednotek Dos, Crt,...)
                         0...Nemenit => dle prvniho vyskytu
                         1...Na Dotaz.}
  Pos  : shortint;     { Posun, aktualni odmezereni od leveho okraje }
  SPos : byte;         { Indikovani posunu (z minuleho radku)}
  AktRadek: integer;   { Cislo soucasne zprac. radku vstupniho souboru   }
  Proc : Shortint;     { Signalizuje, zda se nachazime v hlavicce proced.,fce}
  TvrdeMezery : Boolean;  {mezery na tvrdo?}
  UserMax     : Byte;     {Maximalni delka radku}
  AutoDel     : Boolean;  {Zpusob deleni dlouhych radek (True  - automaticky,
                                                         False - rucne)}
  BegPath : string; {aktualni adresar}
  Hour, Min, Sec, Sec100 : Word; {Pomocne promenne pro ureceni casu kompilace}
  Delta, bTime, eTime: LongInt;

{=========================  PROCEDURY A FUNKCE  =============================}
{----------------------------------------------------------------------------}

{                     *****************************                          }
{                     *******   ZASOBNIK   ********                          }
{                     *****************************                          }
{                Procedury a fce pro praci se zasobnikem
}
{--------------------------  StackInit   ------------------------------------}
{  Vytvori prazdny zasobnik  }
procedure StackInit (var Uk: Stack);
begin  {StackInit}
  Uk := nil;
end;   {StackInit}
{--------------------------  StackEmpty  ------------------------------------}
{  Testuje zda je dany zasobnik prazdny  }
function StackEmpty (Uk: Stack): boolean;
begin  {StackEmpty}
  if Uk = nil then StackEmpty := true
    else StackEmpty := false;
end;   {StackEmpty}
{---------------------------------  Push  -----------------------------------}
{  Vrazi na vrchol zasobniku polozku X }
procedure Push (var Uk: Stack; X: StackPolozka);
var Pom: Stack;
begin {Push}
  new (Pom);
  Pom^.Obsah := X;
  Pom^.Dalsi := Uk;
  Uk := Pom;
end;  {Push}
procedure PrettyFinish; Forward;
{---------------------------------  Pop  ------------------------------------}
{ Vybere polozku z vrcholu zasobniku }
procedure Pop (var Uk: Stack; var X: StackPolozka);
var Pom: Stack;
begin  {Pop}
  if not StackEmpty (Uk) then
    begin  {NotEmpty}
      X := Uk^.Obsah;
      Pom := Uk;
      Uk := Uk^.Dalsi;
      dispose (Pom);
    end    {NotEmpty}
  else
    begin
      Message ('Nkde chyb BEGIN nebo je navc END', Red);
      PrettyFinish;
    end;
end;  {Pop}
{-------------------------  StackKill  --------------------------------------}
{ Zrusi zasobnik, uvolni pamet }
procedure StackKill (var Uk: Stack);
var Pom : Stack;
begin {StackKill}
  while Uk <> nil do
    begin {while}
      Pom := Uk;
      Uk := Uk^.Dalsi;
      dispose (Pom);
    end;  {while}
end;  {StackKill}
{----------------------------------------------------------------------------}

{                        ***************************                         }
{                        *******   SEZNAM   ********                         }
{                        ***************************                         }
{            Procedurky a fce pro praci s linearnim seznamem
}
{---------------------------------  Insert  ---------------------------------}
{  Vrazi na zacatek seznamu polozku X }
procedure Insert (var Uk: Seznam; X: SeznPolozka);
var Pom: Seznam;
begin {Insert}
  new (Pom);
  Pom^.Obsah := X;
  Pom^.Dalsi := Uk;
  Uk := Pom;
end;  {Insert}
{-----------------------------------  IsThere  ------------------------------}
{  Hleda polozku X v danem seznamu, vraci true - nalezen, false - nenalezen }
{ Pokud polozku najde, presune ji na zacatek seznamu - urychleni prace -
  ...nejcasteji pouzivana slova se budou vyskytovat (vybublaji) na zacatek
  seznamu.   }
function IsThere (var Uk: Seznam; X: SeznPolozka): boolean;
var
  Found : boolean;
  Pom1, Pom2 : Seznam;
begin {IsThere}
  Found := false;
  Pom1 := Uk;
  Pom2 := nil;
  while (Pom1 <> nil) and not Found do
    begin {while}
      if MyDownCase (Pom1^.Obsah) <> X then
        begin
          Pom2 := Pom1;
          Pom1 := Pom1^.Dalsi;
        end
      else
        Found := true;
    end;  {while}

  if Found and (Pom2 <> nil) then  {Pom2<>nil <=> hledane slovo je na zacatku}
    begin {prehozeni nalezeneho prvku na zacatek seznamu}
      Pom2^.Dalsi := Pom1^.Dalsi;
      Pom1^.Dalsi := Uk;
      Uk := Pom1;
    end; {prehozeni nalezeneho prvku na zacatek seznamu}
  IsThere := Found;
end;  {isthere}
{-------------------------------  IsThereZ  ---------------------------------}
{ Zjisti, zda je dany znak v seznamu znaku a vraci bud:
   nil - nenalezen, neni tam
   nebo ukazatel na tento znak (ketry je jeste k tomu spravne odmezeren)   }
function IsThereZ (Uk: Seznam; X: SeznPolozka): Seznam;
var
  Found: Boolean;
begin { IsThereZ }
  Found := False;
  while (Uk <> nil) and not Found do
    begin {while}
      if SkipAllSpaces (Uk^.Obsah) = X then Found := True
      else Uk := Uk^.Dalsi;
    end;  {while}
  IsThereZ := Uk;
end;  { IsThereZ }
{------------------------------ TakeCase ------------------------------------}
{  Vstup - slovo, ktere je v danem seznamu (lisi se pouze velikosti pismen   }
{  procedura najde a vraci toto slovo (ktere se lisi jen velikosti pismen)   }
procedure TakeCase (Uk: Seznam; var X: SeznPolozka);
var Found : boolean;
begin {Take}
  X := MyDownCase (X);
  Found := false;
  while (Uk <> nil) and not Found do
    begin {while}
      if MyDownCase (Uk^.Obsah) = X then
        begin
          Found := true;
          X := Uk^.Obsah;
        end;
      Uk := Uk^.Dalsi;
    end;  {while}
end;  {Take}
{----------------------------  Erase  ---------------------------------------}
{  Smaze polozku X ze seznamu  }
procedure Erase (var Uk: Seznam; X: SeznPolozka);
var Pom, PredPom: Seznam;
begin {Erase}
  Pom := Uk;
  PredPom := Uk;
  while Pom <> nil do
    begin {while}
      if Pom^.Obsah = X then
        begin {nalezen}
          if Pom = Uk then Uk := Uk^.Dalsi  { X je prvni prvek}
            else
              begin     { X neni prvni prvek }
                while PredPom^.Dalsi <> Pom do PredPom := PredPom^.Dalsi;
                PredPom^.Dalsi := Pom^.Dalsi;
              end;
          dispose (Pom);
          exit;
        end;  {nalezen}
      Pom := Pom^.Dalsi;
    end;  {while}
end;  {Erase}
{--------------------------  JeVPoli  ---------------------------------------}
{  Vrati poradi daneho stringu S v poli stringu P [1..Max], pokud tam neni,  }
{  vraci nulu.    }
function JeVPoli (S: string; P: array of string; Max: byte): byte;
var i, Pom: byte;

begin {JeVPoli}
  Pom := 0;
  for i := 0 to Max - 1 do
    if S = P[i] then Pom := i + 1;
  JeVPoli := Pom;
end; {JeVPoli}
{============================================================================}
{------------------------  PretttyFinish  -----------------------------------}
{ Uvolneni pameti, zruseni linearnich seznamu a zasobniku...}
procedure PrettyFinish;
begin {PrettyFinish}
{Uvolneni pameti: }
  SeznKill (SeznVyjimky);
  SeznKill (SeznZnaky);
  StackKill (Zas);
{Uzavreni vstupniho a vystupniho souboru }
  if AktRadek <> 0 then
    begin  {uz se otevrely tyto soubory}
      close (Fin);
      close (Fout);
    end;   {uz se otevrely tyto soubory}

{Vraceni spravnejch barvicek }
  Window (1,1,80,25);
  StandartScreen;
  Writeln ('  Thank you for using PRETTY PRINT.....');
  Halt;
end; {PrettyFinish}
{--------------------------------  GameOver  ---------------------------------}
{  Pouze se zepta uzivatele, zda chce ukoncit program a pripadne jej ukonci }
procedure GameOver;
var
  Volba : Byte;
begin { GameOver }
  Volba := 2;
  ABCRequest ('Opravdu chcete ukonit program?',Volba, Red, Vodorovne,
    'Ano|Ne|');
  if Volba < 2  then PrettyFinish;
end;  { GameOver }
{---------------------------------  GetPath  ---------------------------------}
{  Vstup - cesta k souboru vcetne jeho nazvu
   Vystup - pouze ta cesta
   Pr.: C:\BLA\BLABLA\blee   --->   C:\BLA\BLABLA\
}
function GetPath (Soubor: string): string;
var
  i : Byte;
begin { GetPath }
  i := Length (Soubor);
  while (Soubor[i] <> '\') and (i>0) do Dec (i);
  if i = 0 then GetPath := ''
  else GetPath := Mid (Soubor, 1, i);
end;  { GetPath }
{----------------------------------  MyVal  ---------------------------------}
{ String --> cislo}
function MyVal (S: string): integer;
var
  Pom1, Pom2 : Integer;
begin { MyVal }
  Val (S, Pom1, Pom2);
  MyVal := Pom1;
end;  { MyVal }
{----------------------------------  MyStr  ---------------------------------}
{ Cislo --> String }
function MyStr (Cislo: longint): string;
var
  Vysledek : string;
begin { MyStr }
  Str (Cislo, Vysledek);
  MyStr := Vysledek;
end;  { MyStr }
{---------------------------  Options  --------------------------------------}
{  Nasatvi vstupni parametry  }
procedure Options;
var
  Pom, Hlaska: string;
  Pom2: Byte;
  Pom3: Integer;
  PomUserUp : Byte;
  Ok : Boolean;
  Okno : pBasicWindow;
  CfgFile: Text;
  PomSlova, PomZnaky: string;
  Skip : boolean;
begin {Options}

 {Implicitni hodnoty:    }
  UserTab := 2;
  UserMax := 78;
  AutoDel := True;
  TvrdeMezery := False;
  AktRadek := 0;
  UserUpDown := 0;    {0...prvni vyskyt, 1...rucne}

  Pozadi (Sroub, Cyan); {Sroubovite pozadi}
 {Uvodni hlaska}
  Message ('P R E T T Y     P R I N T' +
          'verse 1.3     13. jna 1996'+
	  'Petr Vclavek  Svobodova 145, Vidnava 790 55',Blue);

  Ok := False;
 {Koukne se, zda existuje soubor pretty.cfg (v aktualnim adresari), pokud
  ano, nabidne uzivateli jako soubory se slovy a znaky soubory, ktere jsou
  ulozeny v tomto konfiguracnim souboru}

  {$I-}
  assign (CfgFile, BegPath + '\pretty.cfg');
  reset (CfgFile);
  Readln (CfgFile, PomSlova);
  Readln (CfgFile, PomZnaky);
  close (CfgFile);
  {$I+}
  Skip := IOResult = 0;
  {Pokud bez chyb, preskoc zadavani souboru slov a znaku}

  while not Ok do
 {Vlastni zadavani parametru}

    begin {zadavani paramatru}
      repeat
        UserFIn := ReadFile ('Zadej vstupn soubor:','',True);
        if UserFIn = '' then GameOver;
      until UserFin <> '';

      repeat
        UserFOut := ReadFile ('Zadej vstupn soubor:', GetPath (UserFIn),
          False);
        if UserFOut = '' then GameOver;
      until UserFOut <> '';

      if Skip then
        repeat {Zepta se, zda pouzit soubory z CFG}
          Pom2 := 1;
          ABCRequest ('Pout jako datov soubory tyto soubory '+
           + PomSlova + '' + PomZnaky + '' +
           'zadan v konfiguranm souboru?', Pom2, Blue, Vodorovne,
           'Ano|Ne|');
          if Pom2 = 0 then GameOver;
          if Pom2 = 2 then Skip := False;
        until Pom2 <> 0;

      if not Skip then
        begin{ preskoceni zadavani souboru slov a znaku }
          repeat
            UserFVyj := ReadFile (
              'Zadej soubor obsahujc spravne napsana (velk/mal psmena) slova',
            GetPath (UserFOut), True);
            if UserFVyj = '' then GameOver;
          until UserFVyj <> '';

          repeat
            UserFZnaky := ReadFile (
             'Zadej soubor obsahujc sprvn odmezeen znaky',GetPath (UserFVyj),
              True);
            if UserFZnaky = '' then GameOver;
          until UserFZnaky <> '';
        end { preskoceni zadavani souboru slov a znaku }

      else

        begin {soubor znaku a slov z Cfg_souboru}
          UserFVyj := PomSlova;
          UserFZnaky := PomZnaky;
        end; {soubor znaku a slov z Cfg_souboru}

      repeat
        Pom := MyStr (UserTab);
        ReadString ('Zadej velikost tabeltoru (0..5):', Pom, '012345',
	  Blue,4);
        if Pom = '' then GameOver
        else
          if Length (Pom) > 1 then Pom := ''
            else UserTab := MyVal (Pom);
      until Pom <> '';

      repeat
        Pom2 := UserUpDown + 1;
        ABCRequest (
          'Pokud nkter slovo nen v seznamu jak se m upravit - podle ' +
          'prvnho vskytu nebo run?', Pom2, Blue, Vodorovne,
	  'Prvn vskyt|Run|');
        if Pom2 = 0 then GameOver
        else UserUpDown := Pom2 - 1;
      until Pom2 <> 0;

      repeat
        Pom2 := Ord (TvrdeMezery) + 1;
        ABCRequest (
	  'Odmezeovn znaku - nechat stvajc mezery a ppadn pidat '+
	  'nebo tvrd mezery (pesn podle vzoru uvedench v souboru)?',
          Pom2, Blue, Vodorovne, 'Nechat Stvajc|Tvrd mezery|');
        if Pom2 = 0 then GameOver
        else TvrdeMezery := Pom2 = 2;
      until Pom2 <> 0;

      repeat
        Pom3 := 0;
        Pom := MyStr (UserMax);
        ReadString ('Zadej maximaln dlku dku (60..137):', Pom, Cisla,
	  Blue,6);
        if pom = '' then GameOver
        else
          if Length (Pom) > 3 then Pom3 := 0
            else
              begin {}
                Pom3 := MyVal (Pom);
                if (Pom3 > 59) and (Pom3 < 138) then UserMax := Pom3
                else Pom3 := 0;
	      end; {}
      until Pom3 <> 0;

      repeat
        Pom2 := Ord (AutoDel) + 1;
        ABCRequest (
          'Jak provdt dlen dlouhch dk - run nebo automaticky '+
	  'dle uven potae?',
          Pom2, Blue, Vodorovne, 'Run|Automaticky|');
        if Pom2 = 0 then GameOver
        else AutoDel := Pom2 = 2;
      until Pom2 <> 0;


      PaintWindow (5,4,75,22, Green + 8, Green, 'Options', Single);
      Window (7,5,74,21);
      SetColors (White, Green);

      Writeln ('Vstupn soubor   : ', UserFIn);
      Writeln ('Vstupn soubor  : ', UserFOut);
      Writeln ('Soubor se slovy  : ', UserFVyj);
      Writeln ('Soubor se znaky  : ', UserFZnaky);
      GotoXY (1, 12);
      Writeln ('Velikost tabeltoru   : ', UserTab);
      Write   ('prava neznmch slov : ');
      if UserUpDown = 0 then Writeln ('Prvn vskyt')
      else Writeln ('Run');

      Write ('Mezery                : ');
      if TvrdeMezery then Writeln ('Tvrd')
      else Writeln ('Nechat stvajc');

      Writeln ('Max. dlka dku      : ',UserMax);
      Write ('Dlen dku          : ');
      if AutoDel then Writeln ('Automaticky')
      else Writeln ('Run');

      Window (1,1,80,25); {Zpatky velky vokno}

      repeat
        Pom2 := 1;
        ABCRequest ('Je vechno OK?',Pom2, Red, Vodorovne, 'Ano|Ne|');
        if Pom2 = 0 then GameOver
        else Ok := Pom2 = 1;
      until Pom2 <> 0;

      Pozadi (Sroub, Cyan);

    end; {zadavani paramatru}

 {Hlavni okno}
  PaintWindow (1,1,80,25,White,Blue,'Pretty Print',Double);

  SetColors (Yellow, Blue);
  Window (2,2,79,24);
(*
    {----------  Ladici nastaveni  ------------}
  UserTab := 0;      {}
  UserMax := 60;     {}
  AutoDel := False;   {}
  TvrdeMezery := True;  {}

  UserFIn := 'c:\pv\tvorba\pascal\matfyz\pretty2\vstup.pas';
  UserFOut := 'c:\pv\tvorba\pascal\matfyz\pretty2\vystup.pas';
  UserFVyj := 'c:\pv\tvorba\pascal\matfyz\pretty2\vyjimky.dat';
  UserFZnaky := 'c:\pv\tvorba\pascal\matfyz\pretty2\znaky.dat';
  userUpDown := 0;    {} {0...nechat, 1...dotaz}
*)
end;  {Options}

{----------------------------  PrettyInit  ----------------------------------}
{  Nastavi hlavni globalni promenne, vytvori linearni seznam vyjimek,
   inicializuje zasobnik... }
procedure PrettyInit;
var i, j, N : byte;
    Rad: string;
    Fil: File;
begin {PrettyInit}
{ Zasobnik a seznam }
  StackInit (Zas);    {Zasobnik na odmezerovani a vnorovani cyklu}

  SeznInit (SeznVyjimky);
  {$I-}
  assign (FVyj, UserFVyj);
  reset (FVyj);
  {$I+}
  if IOResult <> 0 then
    begin {}
      Message ('I/O Chyba - nejspe patn zadan soubor (cesta) v ' +
               'konfiguranm souboru Pretty.cfg', Red);
      PrettyFinish;
    end; {}
  while not eof (FVyj) do
    begin {nacitani vyjimek do seznamu}
      Rad := ReadLine (FVyj);
      if (Rad <> '') and (Rad [1] <> '%') then Insert (SeznVyjimky, Rad);
    end; {nacitani vyjimek do seznamu}
  close (FVyj);

  {$I-}
  assign (FZnaky, UserFZnaky);
  reset (FZnaky);
  {$I+}
  if IOResult <> 0 then
    begin {}
      Message ('I/O Chyba - nejspe patn zadan soubor (cesta) v ' +
               'konfiguranm souboru Pretty.cfg', Red);
      PrettyFinish;
    end; {}

  while not eof (FZnaky) do
    begin {nacitani vyjimek do seznamu}
      Rad := ReadLine (FZnaky);
      if (Rad <> '') and (Rad [1] <> '%') then
        begin
          N := Length (Rad);
          for i := 1 to N do {nahrazeni mezer "_" --> " "}
            if Rad[i] = '_' then Rad[i] := ' ';
          Insert (SeznZnaky, Rad);
        end;
    end; {nacitani vyjimek do seznamu}
  close (FZnaky);

{ Globalni promenne }
  Kom := 0;        { Jestli je v komentari }
  Txt := false;    { Jestli je v textu (v apostrofech) }
  NewRad := '';    { Nasledujici radek }
  AktRadek := 0;   { Cislo aktualniho radku }
  SPos := 0;       { Signalizace posunu }
  Pos := 0;
  Proc := -1;      { Jestli je v hlavicce procedury nebo fce }
{ Priprava vstupniho a vystupniho souboru }
{ Otestuje se zda vstupni soubor = vystupnimu a pokud ano, tak se vytvori
  zalozni soubor (koncovka .BAK)  }

  if UserFin = UserFout then
    begin {vytvori se zaloha (.bak) a vstup bude z teto zalohy}
      Assign (Fin, UserFIn);
      i := Length (UserFin);
      while (UserFin [i] <> '.') and (UserFin [i] <> '\') do Dec (i);
      if UserFin [i] = '.' then {s koncovkou}
          UserFin := Mid (UserFin,1,i) + 'bak'
      else {bez koncovky}
          UserFin := UserFin + '.bak';
      Rename (Fin, UserFIn);
    end; {vytvori se zaloha (.bak) a vstup bude z teto zalohy}

  Assign (Fin, UserFIn);
  Assign (Fout, UserFOut);

  Reset (Fin);
  Rewrite (Fout);
end; {PrettyInit}
{-----------------------  SkipSpaces  ---------------------------------------}
{  Fce vynecha uvodni mezery a tabelatory ve stringu R }
function SkipSpaces (R: string): string;
var i, N :byte;

begin {SkipSpaces}
  N := length (R);
  i := 1;
  while (R[i] = ' ') or (R[i] = #9) do inc (i);
  SkipSpaces := Mid (R, i, N);
end;  {SkipSpaces}
{----------------------------  SkipComm  ------------------------------------}
{ Vytahne ze stringu S komentar, ktery vraci.}
{ Timto se zkrati string S (o ten komentar) }
function SkipComm (var S: string): string;
var i, N: byte;
begin {SkipComm}

  if (S[1] = '{') and (Kom <> 2) then Kom := 1;
  if (S[1] = '(') and (S[2] = '*') and (Kom <> 1) then Kom := 2;
  If Kom <> 0 then
    begin {Kom <> 0}
      N := length (S);
      i := 1;
      while (Kom <> 0) and (i <= N) do
        begin
          if (S[i] = '}') and (Kom = 1) then Kom := 0;
          if (S[i - 1] = '*') and (S[i] = ')') and (Kom = 2) then Kom := 0;
          inc (i);
        end;
      dec (i);
      SkipComm := Mid (S, 1, i);
      S := Mid (S, i+1, length (S));
      NewRad := S;
    end  {Kom <> 0}
  else SkipComm := '';
end;  {SkipComm}
{-----------------------------  SkipTxt  ------------------------------------}
{ Vytahne ze stringu S text uzavreny v apostrofech, ktery vraci.
 string S se timto zkrati o dany text }
function SkipTxt (var S: string): string;
var i, N: byte;
begin {SkipTxt}
  if (S[1] = '''') or Txt then
    begin
      Txt := true;
      N := length (S);
      i := 1;
      while (S[i] <> '''') and (i <= N) do inc (i);
      if S[i] = '''' then
        begin
          Txt := false;
        end;
      SkipTxt := Mid (S, 1, i);
      S := Mid (S, i+1, length (S));
    end;
end; {SkipTxt}


{----------------------------  Word  ----------------------------------------}
{  Vstup - retezec, ktery zacina znakem ze seznamu BeginOfWord               }
{  Vraci prvni cele slovo (identifikator, vyhrazene slovo,...) ze stringu S  }
{  Slovoa jsou oddelena znaky - oddelovace }
{  Zmeni hodnotu stringu S - ubude z nej prvni slovo                         }
function Word (var S: string): string;
var i, N : byte;
     Pom : string;
    {Word - obsahuje to slovo}

begin {Word}
  N := length (S);
  Pom := '';
  i := 1;
    while (not (S[i] in Oddel)) and (i <= N) do
      begin { neni to oddelovac }
        Pom := Pom + S[i];
        inc (i);
      end;  { neni to oddelovac }
  S := Mid (S, i, N);
  Word := Pom;
end; {Word}
{--------------------------------  Test  ------------------------------------}
{ Pomocna procedurka pri ladeni (vypise vsechna "slova" z dane radky) }
procedure Test (S: string);
var i, N, k: byte;
    Slovo  : string;
    Znak : char;
begin
  N := length (S);
  i := 1;
  while  S <> '' do
    begin
      Znak := S[1];
      if not (Znak in BeginOfWord) then S := Mid (S, 2, length (S))
      else
        begin {}
          Slovo := Word (S);
          write ('-------',Slovo);

        end; {}
    end;
  readln;
end;
{--------------------------  UserUpcase  ------------------------------------}
{ vraci upravene Slovo - zmena velkych a malych pismenek
  Pokud je obsazeno v souboru "vyjimek" (neboli v souboru, ktery obsahuje
  spravne up/down casnuta slova) upravi se velikost pismen podle vzoru
  v tomto souboru, pokud tam neni, jedna podle nastavenych hodnot
  (bud se zepta uzivatele nebo ho necha byt)
}
function UserUpcase (Slovo: string): string;
var Pom : string;
    OldSlovo: string;  {Uchovava slovo s puvodnim UpCasem}
begin {UserUpcase}
  Pom := '';
  OldSlovo := Slovo;
  Slovo := MyDownCase (Slovo);

  if IsThere (SeznVyjimky, Slovo) then
    begin {Je ve vyjimkach }
      Pom := Slovo;
      TakeCase (SeznVyjimky, Pom);

    end   {Je ve vyjimkach }
  else
       { Koukne se do seznamu, pokud tam neni - zepta se uzivatele, jak ho
        napsat, nebo necha prvni vyskyt, prida ho do seznamu}
    begin { Prvni vyskyt }
      if UserUpDown = 0 then Pom := OldSlovo
      else {co nam zbejva??}
        repeat {Dotaz}
          if pom = '' then Pom := OldSlovo;
          ReadString ('Zadejte sprvn (velk/mal psmena):',
	    Pom, Slovo + MyUpCase (Slovo), Red,
	    Length (Slovo) + 2); {at je trochu mista}
          if Pom = '' then GameOver;
        until (Pom <> '') and (MyDownCase (Pom) = Slovo); {Dotaz}
      Insert (SeznVyjimky, Pom);  { Pridani do seznamu}
    end;  { Prvni vyskyt }
  UserUpCase := Pom;
end; {UserUpcase}
{-----------------------  Cyklus  -------------------------------------------}
procedure Cyklus (Slovo: string; var S, SS: string);
{ Slovo - slovo z pole Cykly, S - zbytek radky, SS - vystup                  }
{ Procedura upravi posun (POS) a pripadne odradkuje                          }
var Pom, PomS : string;
    Poradi : byte;
    PomZas : StackPolozka;
begin { Cyklus }
  Pom := '';
  Poradi := JeVPoli (Slovo, Cykly, MaxCykly);
  case Poradi of
    {------------------}
    MinCykl1..MaxCykl1 :
      begin {case, asm, begin, record, object, repeat}
        if (SkipSpaces (SS) <> '') and (Poradi <= FirstCykl1) then
          begin { Neni na samostatne radce }
            NewRad := NewRad + Slovo + S;
            exit;
          end;  { Neni na samostatne radce }

        if SPos > 0 then
          begin { Indikovan posun z minula}
            Pos := Pos + SPos;
          end;  { Indikovan posun z minula}

        PomZas.Prikaz := Slovo;
        PomZas.Posun := SPos;       {POZNAMKA: Stacilo by ukladat jen posun}
        Push (Zas, PomZas);
        Inc (Pos);
        if Poradi > FirstCykl2 then
          begin
            S := SkipSpaces (S);
            if S[1] = ';' then S := Mid (S, 2, length (S));
            S := SkipSpaces (S);
            Pom := SkipComm(S)
          end;
        SS := SS + UserUpCase (Slovo) + Pom;
        if Poradi > FirstCykl2 then NewRad := S;  {Odradkovani}
        SPos := 0;
      end; {case, asm, begin, record, object, repeat}
    {------------------}
    MinCykl2..MaxCykl2:
      begin {end, until}
        if SkipSpaces (SS) <> '' then
          begin { Neni na samostatne radce }
            NewRad := NewRad + Slovo + S;
            exit;
          end;  { Neni na samostatne radce }


        Pop (Zas, PomZas);
        dec (Pos);
        Pos := Pos - PomZas.Posun;
        SS := Mid (SS, 1, length (SS) - UserTab);
        SS := SS + UserUpCase (Slovo);
      end; {end, until}
    {------------------}
    MinCykl3..MaxCykl3:
      begin {then, else, do}
        Pom := '';
        PomS := S;
        S := SkipSpaces (S);
        Pom := SkipComm (S);
        SS := SS + UserUpCase (Slovo) + Pom;
        if length (S) = 0 then
	  begin
	    inc (SPos);  {pokracuje na dalsim radku}
            exit;
          end;
	S := SkipSpaces (S);
        if S[1] in BeginOfWord then
          begin
            Pom := Word (S);
            if JeVPoli (Pom, Cykly2, MaxCykly2) <> 0 then
              begin {Odradkuj}
                inc (SPos);
                NewRad := PomS;
              end  {Odradkuj}
            else
              begin {}
                {inc (SPos);}
                SPos := 0;
                S := PomS;
              end; {}
          end;
      end; {then, else, do}
    {------------------------}
    MinCykl4..MaxCykl4:
      begin {Deklarace}
        if (Proc = -1) then
          begin {Zacatek Deklarace}
            {zkontroluje, zda uvodni slovo deklarace je na zacatku radky}
            if SkipSpaces (SS) <> '' then
              begin {neni na samostatne radce}
                NewRad := NewRad + Slovo + S;
                exit;
              end;  {neni na samostatne radce}

            if Dek = True then
              begin {uz byl v deklaraci}
                Dec (Pos);
                SS := Mid (SS, 1, Length (SS) - UserTab);
                Dek := False;
              end; {uz byl v deklaraci}
            Dek := True;   {nastaveni flagu bloku deklarace}
            Inc (Pos);
            {Koukne se, zda radek jeste pokracuje, pokud ano, odradkuje}
            if SkipSpaces (S) <> '' then
              begin {}
                NewRad := S;
              end; {}
          end;   {Zacatek Deklarace}
          SS := SS + UserUpCase (Slovo);
      end; {Deklarace}
  end; {Case}
end;  { Cyklus }
{--------------------------  Znak  ------------------------------------------}
{ Procedurka spravne odmezeri dany znak
  Vstup - Z....Znak, S...Radek, ktery obsahoval tento znak na zacatku,
          SS...Vystupni string (se spravne odmezerenym znakem.               }
procedure Znak (Z: char; var S, SS : string);
var
  Za, Pom, PomS, Slovo: string;
  OdZ: string; {Cely odmezerovany znak}
  VSeznamu : Boolean;
begin {Znak}
  S := Mid (S, 2, length (S)); {uz je bez toho znaku}
  Za := ''; OdZ := '';

  case Z of
 {Specialni znaky:}
  ';':
    begin {strednik}
      PomS := SkipSpaces (S);
      Slovo := MyDownCase (Word (PomS));
      if (Proc<=0) and (JeVPoli (Slovo, ZaProc, MaxZaProc)=0) then
        begin {na konci radku}
          S := SkipSpaces (S);
          Za := SkipComm (S);
          NewRad := S;
          Proc := -1;
        end {na konci radku}
    end; {strednik}
  '(': begin
         if S[1] = '*' then
           begin {}
             S := Mid (S, 2, Length (S));
             Kom := 2;
             Za := SkipComm (S);
             OdZ := '(*';
             if (SkipSpaces (SS) = '') and Dek then
               begin {}
                 SS := Mid (SS, 1, Length (SS) - UserTab);
               end; {}
           end {}
         else
	   if Proc >= 0 then inc (Proc);
       end;
  ')': begin
         dec (Proc);
         if Proc = 0 then Proc := -1;
       end;
  '{': begin
         Kom := 1;
	 Za := SkipComm (S);
         if (SkipSpaces (SS) = '') and Dek then
           begin {}
             SS := Mid (SS, 1, Length (SS) - UserTab);
           end; {}

       end;
  '''':begin {}
         Txt := true;
         Za := SkipTxt (S);
       end; {}
  #9  :Z := ' ';
    end; {case}

  if OdZ = '' then OdZ := Z;
  PomS := SkipSpaces (S);  {Dvoumistne znaky (<>, :=, >=,...)}
  if (Length (OdZ) <= 1) and (IsThereZ (SeznZnaky, OdZ + PomS[1]) <> nil) then
    begin
      OdZ := OdZ + S[1];
      S := Mid (PomS, 2, Length(S));
    end;

  VSeznamu := False;
  if IsThereZ (SeznZnaky, OdZ) <> nil then
    begin {Je ve vyjimkach }
      OdZ := IsThereZ (SeznZnaky, OdZ)^.Obsah;
      VSeznamu := true;
    end;  {Je ve vyjimkach }

  if TvrdeMezery and VSeznamu then
    begin {}
      S := SkipBegSpaces (S);
      PomS := SkipEndSpaces (SS);
      If not (PomS [Length(PomS)] in Oddel) then
        SS := PomS
      else
        if (SS [length (SS)] = ' ') and (OdZ[1] = ' ') then
          OdZ := Mid (OdZ, 2, Length (OdZ));
    end   {}
  else
    if OdZ <> ' ' then
      begin
        if (SS [length (SS)] = ' ') and (OdZ[1] = ' ') then
          OdZ := Mid (OdZ, 2, Length (OdZ));
        if (S[1] = ' ') and (OdZ [Length (OdZ)] = ' ') then
          OdZ := Mid (OdZ,1,Length (OdZ) - 1);
      end;
  SS := SS + OdZ + Za;
end;  {znak}
{-----------------------  Arrange  ------------------------------------------}
{  Hlavni funkce celeho programu
   Vsup - radka zdrojoveho programu, ktera se touto funkci spravne upravi
   Vystup - upravena radka.     }
function Arrange (S: string): string;
var SS    : string;           { Upravena radka }
    Slovo, OldSlovo : string;
    PomS : string;
    Pre, Za, Mezi : string;
    Z : char;      {Znak}

begin {Arrange}
  SS := '';

{ Pokud je na zacatku radky komentar, nebo text v apostrofech, tak se
  preskoci a odradkuje na novou radku }
  if (Kom <> 0) or Txt then
    begin { Komentar & Text v apostrofech}
      if Kom <> 0 then SS := SkipComm (S);
      if Txt then SS := SkipTxt (S);
      NewRad := S;
    end  {Komentar & Text v apostrofech}

  else   { Neni tam ani komentar ani text v '', zacina rovnou program...}
    begin {Dal..}
      S := SkipSpaces (S);  { Preskoci uvodni mezery }
      SS := SS + NSpaces (Pos*UserTab);  {Pocatecni odmezereni}
      if SPos > 0 then
        begin { SPos > 0 }
          SS := SS + NSpaces (SPos*UserTab);
          PomS := S;
          if JeVPoli (MyDowncase (Word (S)), Cykly2, MaxCykly2) = 0 then
	    SPos := 0;
          S := PomS;
        end;  { SPos > 0 }

      while (NewRad = '') and (length (S) <> 0) do
        begin {Vlastni zpracovani radky}
          Z := S[1];
          if Z in BeginOfWord then
            begin {je to Slovo}
              Slovo := Word (S);
              OldSlovo := Slovo;       {Zachova se UpCase/DownCase}
              Slovo := MyDownCase (Slovo);
              {kontrola konce deklarace}
              if Dek and StackEmpty (Zas) and
                (JeVPoli (Slovo, EndDek, MaxEndDek) <> 0) then
                  begin {}
                    Dek := False;
                    Dec (Pos);
                    SS := Mid (SS, UserTab+1, Length (SS));
                  end; {}
              if JeVPoli (Slovo, Cykly, MaxCykly) <> 0 then
	        Cyklus (Slovo, S, SS) { Upravi se posun }
              else
                begin {jine (normalni) slovo}
                  if JeVPoli (Slovo, ProcFce, MaxProcFce) <> 0 then
		    Proc := 0;
                  SS := SS + UserUpcase (OldSlovo);
                end; {jine (normalni) slovo}
            end {je to Slovo}

          else {Znak not in BeginOfWord => Je to znak}
	    Znak (Z, S, SS);
        end {Vlastni zpracovani radky}
    end;  {(else) Dal..}
  Arrange := SS;
end; {Arrange}

{----------------------------  RucneZkrat  ----------------------------------}
{ Vlastni rucni deleni radky }
function RucneZkrat (Retez: string): byte;
var
  Znak: Char;
  OldAttr: Attrib;
  DelkaStr,DelkaOkna,First, X, Y, XX: Byte;
  Okno : pBasicWindow;

begin { RucneZkrat }

  SaveAttrib (OldAttr);
  X := 2;
  Y := 12;
  DelkaOkna := 77;

  Okno := New (pBasicWindow, Init (X, 10,X+DelkaOkna, 13, Red+8, Red, '',Single));
  Okno^.Open;

  SetColors (White, Red);
  WriteXY (X + 6,11,'      Uprav dlku tohoto dku:');

  SetColors (white, Black);

  First := 1;
  XX := 1;
  DelkaStr := Length (Retez);
  Obdelnik (X+1,Y,X+DelkaOkna-1,Y,Black);
  WriteXY (X+1,Y,Mid (Retez, First, First + DelkaOkna - 2));

  repeat
    GotoXY (X+1 + XX - First, Y);
    Znak := Readkey;
    if Znak = #00 then
      begin {#00}
        Znak := ReadKey;
        case Znak of
          Right:
            if XX < DelkaStr then    {Jde-li to vubec}
              begin {}
                if XX - First + 2 = DelkaOkna then { Na konci policka }
                  Inc (First);
                Inc (XX);
              end; {}
          Left:
            if XX > 1 then          {Jde-li to vubec}
              begin
                if XX = First then    {Uplne na zacatku (Na obrazovce)}
                  Dec (First);
                Dec (XX);
              end;

          Home:
            begin {}
              First := 1;
              XX := 1;
            end; {}

          EndKey:
            begin
              XX := DelkaStr;
              if DelkaStr > DelkaOkna then First := DelkaStr - DelkaOkna + 2
              else First := 1;
            end;
        end; {Case}
        Obdelnik (X+1,Y,X+DelkaOkna-1,Y,Black);
        WriteXY (X+1,Y,Mid (Retez, First, First + DelkaOkna - 2));
      end; {#00}

    if Znak = Esc Then GameOver;
  until Znak = Enter;

  RucneZkrat := XX - 1;
  Okno^.Close;
  LoadAttrib (OldAttr);
end;  { RucneZkrat }

{-----------------------------------  Zkrat  ---------------------------------}
{S..stare, SS - nove}
procedure Zkrat (var S,SS: string);
var
  i,j: Byte;
  Apostr, Ok : Boolean;

begin { Zkrat }
  Apostr := False;    {radek nemuze zacinat textem v apostrofech, ktery by
                       zacinal na predchozim radku!}
  for i := 1 to UserMax do
    if S[i] = '''' then Apostr := not Apostr;

  if AutoDel and not Apostr then
    begin {Automaticke deleni bez apostrofu}
      i := UserMax;
      while (not (S[i] in KonecRadky)) and (i>0) do Dec (i);
      if i = 0 then i := UserMax; {Pouze pokud je nejaky dlouhy
	retezec v komentari jinak je to nemozne}
    end;  {Automaticke deleni bez apostrofu}

  if not AutoDel then
    begin {Rucni deleni}
      {Okno := New (pBasicWindow, Init())}
      repeat
        Ok := True;
        i := RucneZkrat (Mid (S, 1, UserMax+1));
        if (S[i] in Oddel) or (S[i+1] in Oddel) then Ok := False;
        if JeVPoli (S[i]+S[i+1], Nedelit, MaxNedelit) <> 0 then Ok := False;
      until not Ok;

      Apostr := false;
      for j := 1 to i do
        if S[j] = '''' then Apostr := not Apostr;
    end; {Rucni deleni}

  if Apostr then
    begin {Apostrofy}
      j := i;
      while S[j] <> '''' do dec (j);
      if (UserMax - j < 10)
      and (S[j+1] <> '''') and ((j>1) and (S[j-1] <> '''')) then
      {to je silena podminka - deleni apostrofu v apostrofu}
        begin {konec apostrofu}
          SS := Mid (S, 1, j-1);
          S := Mid (S, j, Length (S));
        end {konec apostrofu}
      else
        begin {dlouhej text v ''}
          SS := Mid (S, 1, UserMax-2);{ + '''+';}
          if (S[UserMax-2] = '''') and (S[UserMax-1] = '''') then
            begin
              SS := SS + '''''+';
              S := Mid (S,2,Length (S));  {aby tam nebylo moc tech apostr}
            end
          else SS := SS + '''+';
          S := '''' + Mid (S, UserMax-1, Length (S));
        end; {dlouhej text v ''}
    end {Apostrofy}
  else
    begin { Bez Apostrofu}
      SS := Mid (S, 1, i);
      S := Mid (S, i+1, Length (S));
    end; { Bez Apostrofu}

  {doplnime uvodni mezery}
  i := 1;
  while SS[i] = ' ' do Inc (i);
  S := NSpaces (i-1) + SkipSpaces (S);
end;  { Zkrat }
{==========================  VLASTNI PROGRAM  ===============================}
begin {VLASTNI PROGRAM}
  GetDir (0, BegPath); {aktualni adresar}
  Options;    { Nastavi se parametry Pretty printu }
  PrettyInit; { Init seznamu, zasobniku, promennych }
  {nastaveni pocatecniho casu}
  GetTime (Hour, Min, Sec, Sec100);
  bTime := Hour;
  bTime := bTime*3600 + Min*60 + Sec;

  while not eof (Fin) or (NewRad <> '') do
    begin
      Inc (AktRadek);
      if NewRad = '' then ReadLn (Fin, Rad)
      else
	begin
	  Rad := NewRad;
          NewRad := '';
        end;

      Rad := Arrange (Rad);

      while Length (Rad) > UserMax do
        begin {Zkracovani radku}
          Zkrat (Rad, PomRad);
          WriteLn (Fout, PomRad);
          Writeln (PomRad);
        end; {Zkracovani radku}

      WriteLn (Fout, Rad);
      Writeln (Rad);
      if Keypressed then
        begin
          ReadKey;
          GameOver;
        end;
    end;

  GetTime (Hour, Min, Sec, Sec100);
  eTime := Hour;
  eTime := 3600*eTime + 60*Min + Sec;
  if eTime - bTime < 0 then
    Delta := eTime + 86400 {24 Hod} - bTime
  else Delta := eTime - bTime;



  Message ('Ve probhlo v podku, vstup byl zapsn do tohoto souboru: ' +
    UserFOut + 'Doba zpracovn:' +
    MyStr (Delta div 3600) + ' hod '+
    MyStr ((Delta mod 3600) div 60) + ' min '+
    MyStr ((Delta mod 3600) mod 60) +  ' sec', Green);
  PrettyFinish;    { Zruseni seznamu, uvolneni pameti }

end.  {VLASTNI PROGRAM}
{============================================================================}